import re

emojis = [{"code":"00A9","sn":"copyright"},{"code":"00AE","sn":"registered"},{"code":"203C","sn":"bangbang"},{"code":"2049","sn":"interrobang"},{"code":"2122","sn":"tm"},{"code":"2139","sn":"information_source"},{"code":"2194","sn":"left_right_arrow"},{"code":"2195","sn":"arrow_up_down"},{"code":"2196","sn":"arrow_upper_left"},{"code":"2197","sn":"arrow_upper_right"},{"code":"2198","sn":"arrow_lower_right"},{"code":"2199","sn":"arrow_lower_left"},{"code":"21A9","sn":"leftwards_arrow_with_hook"},{"code":"21AA","sn":"arrow_right_hook"},{"code":"231A","sn":"watch"},{"code":"231B","sn":"hourglass"},{"code":"2328","sn":"keyboard"},{"code":"23CF","sn":"eject"},{"code":"23E9","sn":"fast_forward"},{"code":"23EA","sn":"rewind"},{"code":"23EB","sn":"arrow_double_up"},{"code":"23EC","sn":"arrow_double_down"},{"code":"23ED","sn":"black_right_pointing_double_triangle_with_vertical_bar"},{"code":"23EE","sn":"black_left_pointing_double_triangle_with_vertical_bar"},{"code":"23EF","sn":"black_right_pointing_triangle_with_double_vertical_bar"},{"code":"23F0","sn":"alarm_clock"},{"code":"23F1","sn":"stopwatch"},{"code":"23F2","sn":"timer_clock"},{"code":"23F3","sn":"hourglass_flowing_sand"},{"code":"23F8","sn":"double_vertical_bar"},{"code":"23F9","sn":"black_square_for_stop"},{"code":"23FA","sn":"black_circle_for_record"},{"code":"24C2","sn":"m"},{"code":"25AA","sn":"black_small_square"},{"code":"25AB","sn":"white_small_square"},{"code":"25B6","sn":"arrow_forward"},{"code":"25C0","sn":"arrow_backward"},{"code":"25FB","sn":"white_medium_square"},{"code":"25FC","sn":"black_medium_square"},{"code":"25FD","sn":"white_medium_small_square"},{"code":"25FE","sn":"black_medium_small_square"},{"code":"2600","sn":"sunny"},{"code":"2601","sn":"cloud"},{"code":"2602","sn":"umbrella"},{"code":"2603","sn":"snowman"},{"code":"2604","sn":"comet"},{"code":"260E","sn":"phone"},{"code":"2611","sn":"ballot_box_with_check"},{"code":"2614","sn":"umbrella_with_rain_drops"},{"code":"2615","sn":"coffee"},{"code":"2618","sn":"shamrock"},{"code":"261D","sn":"point_up"},{"code":"2620","sn":"skull_and_crossbones"},{"code":"2622","sn":"radioactive_sign"},{"code":"2623","sn":"biohazard_sign"},{"code":"2626","sn":"orthodox_cross"},{"code":"262A","sn":"star_and_crescent"},{"code":"262E","sn":"peace_symbol"},{"code":"262F","sn":"yin_yang"},{"code":"2638","sn":"wheel_of_dharma"},{"code":"2639","sn":"white_frowning_face"},{"code":"263A","sn":"relaxed"},{"code":"2648","sn":"aries"},{"code":"2649","sn":"taurus"},{"code":"264A","sn":"gemini"},{"code":"264B","sn":"cancer"},{"code":"264C","sn":"leo"},{"code":"264D","sn":"virgo"},{"code":"264E","sn":"libra"},{"code":"264F","sn":"scorpius"},{"code":"2650","sn":"sagittarius"},{"code":"2651","sn":"capricorn"},{"code":"2652","sn":"aquarius"},{"code":"2653","sn":"pisces"},{"code":"2660","sn":"spades"},{"code":"2663","sn":"clubs"},{"code":"2665","sn":"hearts"},{"code":"2666","sn":"diamonds"},{"code":"2668","sn":"hotsprings"},{"code":"267B","sn":"recycle"},{"code":"267F","sn":"wheelchair"},{"code":"2692","sn":"hammer_and_pick"},{"code":"2693","sn":"anchor"},{"code":"2694","sn":"crossed_swords"},{"code":"2696","sn":"scales"},{"code":"2697","sn":"alembic"},{"code":"2699","sn":"gear"},{"code":"269B","sn":"atom_symbol"},{"code":"269C","sn":"fleur_de_lis"},{"code":"26A0","sn":"warning"},{"code":"26A1","sn":"zap"},{"code":"26AA","sn":"white_circle"},{"code":"26AB","sn":"black_circle"},{"code":"26B0","sn":"coffin"},{"code":"26B1","sn":"funeral_urn"},{"code":"26BD","sn":"soccer"},{"code":"26BE","sn":"baseball"},{"code":"26C4","sn":"snowman_without_snow"},{"code":"26C5","sn":"partly_sunny"},{"code":"26C8","sn":"thunder_cloud_and_rain"},{"code":"26CE","sn":"ophiuchus"},{"code":"26CF","sn":"pick"},{"code":"26D1","sn":"helmet_with_white_cross"},{"code":"26D3","sn":"chains"},{"code":"26D4","sn":"no_entry"},{"code":"26E9","sn":"shinto_shrine"},{"code":"26EA","sn":"church"},{"code":"26F0","sn":"mountain"},{"code":"26F1","sn":"umbrella_on_ground"},{"code":"26F2","sn":"fountain"},{"code":"26F3","sn":"golf"},{"code":"26F4","sn":"ferry"},{"code":"26F5","sn":"boat"},{"code":"26F7","sn":"skier"},{"code":"26F8","sn":"ice_skate"},{"code":"26F9","sn":"person_with_ball"},{"code":"26FA","sn":"tent"},{"code":"26FD","sn":"fuelpump"},{"code":"2702","sn":"scissors"},{"code":"2705","sn":"white_check_mark"},{"code":"2708","sn":"airplane"},{"code":"2709","sn":"email"},{"code":"270A","sn":"fist"},{"code":"270B","sn":"hand"},{"code":"270C","sn":"v"},{"code":"270D","sn":"writing_hand"},{"code":"270F","sn":"pencil2"},{"code":"2712","sn":"black_nib"},{"code":"2714","sn":"heavy_check_mark"},{"code":"2716","sn":"heavy_multiplication_x"},{"code":"271D","sn":"latin_cross"},{"code":"2721","sn":"star_of_david"},{"code":"2728","sn":"sparkles"},{"code":"2733","sn":"eight_spoked_asterisk"},{"code":"2734","sn":"eight_pointed_black_star"},{"code":"2744","sn":"snowflake"},{"code":"2747","sn":"sparkle"},{"code":"274C","sn":"x"},{"code":"274E","sn":"negative_squared_cross_mark"},{"code":"2753","sn":"question"},{"code":"2754","sn":"grey_question"},{"code":"2755","sn":"grey_exclamation"},{"code":"2757","sn":"exclamation"},{"code":"2763","sn":"heavy_heart_exclamation_mark_ornament"},{"code":"2764","sn":"heart"},{"code":"2795","sn":"heavy_plus_sign"},{"code":"2796","sn":"heavy_minus_sign"},{"code":"2797","sn":"heavy_division_sign"},{"code":"27A1","sn":"arrow_right"},{"code":"27B0","sn":"curly_loop"},{"code":"27BF","sn":"loop"},{"code":"2934","sn":"arrow_heading_up"},{"code":"2935","sn":"arrow_heading_down"},{"code":"2B05","sn":"arrow_left"},{"code":"2B06","sn":"arrow_up"},{"code":"2B07","sn":"arrow_down"},{"code":"2B1B","sn":"black_large_square"},{"code":"2B1C","sn":"white_large_square"},{"code":"2B50","sn":"star"},{"code":"2B55","sn":"o"},{"code":"3030","sn":"wavy_dash"},{"code":"303D","sn":"part_alternation_mark"},{"code":"3297","sn":"congratulations"},{"code":"3299","sn":"secret"},{"code":"1F004","sn":"mahjong"},{"code":"1F0CF","sn":"black_joker"},{"code":"1F170","sn":"a"},{"code":"1F171","sn":"b"},{"code":"1F17E","sn":"o2"},{"code":"1F17F","sn":"parking"},{"code":"1F18E","sn":"ab"},{"code":"1F191","sn":"cl"},{"code":"1F192","sn":"cool"},{"code":"1F193","sn":"free"},{"code":"1F194","sn":"id"},{"code":"1F195","sn":"new"},{"code":"1F196","sn":"ng"},{"code":"1F197","sn":"ok"},{"code":"1F198","sn":"sos"},{"code":"1F199","sn":"up"},{"code":"1F19A","sn":"vs"},{"code":"1F201","sn":"koko"},{"code":"1F202","sn":"sa"},{"code":"1F21A","sn":"u7121"},{"code":"1F22F","sn":"u6307"},{"code":"1F232","sn":"u7981"},{"code":"1F233","sn":"u7a7a"},{"code":"1F234","sn":"u5408"},{"code":"1F235","sn":"u6e80"},{"code":"1F236","sn":"u6709"},{"code":"1F237","sn":"u6708"},{"code":"1F238","sn":"u7533"},{"code":"1F239","sn":"u5272"},{"code":"1F23A","sn":"u55b6"},{"code":"1F250","sn":"ideograph_advantage"},{"code":"1F251","sn":"accept"},{"code":"1F300","sn":"cyclone"},{"code":"1F301","sn":"foggy"},{"code":"1F302","sn":"closed_umbrella"},{"code":"1F303","sn":"night_with_stars"},{"code":"1F304","sn":"sunrise_over_mountains"},{"code":"1F305","sn":"sunrise"},{"code":"1F306","sn":"city_sunset"},{"code":"1F307","sn":"city_sunrise"},{"code":"1F308","sn":"rainbow"},{"code":"1F309","sn":"bridge_at_night"},{"code":"1F30A","sn":"ocean"},{"code":"1F30B","sn":"volcano"},{"code":"1F30C","sn":"milky_way"},{"code":"1F30D","sn":"earth_africa"},{"code":"1F30E","sn":"earth_americas"},{"code":"1F30F","sn":"earth_asia"},{"code":"1F310","sn":"globe_with_meridians"},{"code":"1F311","sn":"new_moon"},{"code":"1F312","sn":"waxing_crescent_moon"},{"code":"1F313","sn":"first_quarter_moon"},{"code":"1F314","sn":"moon"},{"code":"1F315","sn":"full_moon"},{"code":"1F316","sn":"waning_gibbous_moon"},{"code":"1F317","sn":"last_quarter_moon"},{"code":"1F318","sn":"waning_crescent_moon"},{"code":"1F319","sn":"crescent_moon"},{"code":"1F31A","sn":"new_moon_with_face"},{"code":"1F31B","sn":"first_quarter_moon_with_face"},{"code":"1F31C","sn":"last_quarter_moon_with_face"},{"code":"1F31D","sn":"full_moon_with_face"},{"code":"1F31E","sn":"sun_with_face"},{"code":"1F31F","sn":"star2"},{"code":"1F320","sn":"stars"},{"code":"1F321","sn":"thermometer"},{"code":"1F324","sn":"mostly_sunny"},{"code":"1F325","sn":"barely_sunny"},{"code":"1F326","sn":"partly_sunny_rain"},{"code":"1F327","sn":"rain_cloud"},{"code":"1F328","sn":"snow_cloud"},{"code":"1F329","sn":"lightning"},{"code":"1F32A","sn":"tornado"},{"code":"1F32B","sn":"fog"},{"code":"1F32C","sn":"wind_blowing_face"},{"code":"1F32D","sn":"hotdog"},{"code":"1F32E","sn":"taco"},{"code":"1F32F","sn":"burrito"},{"code":"1F330","sn":"chestnut"},{"code":"1F331","sn":"seedling"},{"code":"1F332","sn":"evergreen_tree"},{"code":"1F333","sn":"deciduous_tree"},{"code":"1F334","sn":"palm_tree"},{"code":"1F335","sn":"cactus"},{"code":"1F336","sn":"hot_pepper"},{"code":"1F337","sn":"tulip"},{"code":"1F338","sn":"cherry_blossom"},{"code":"1F339","sn":"rose"},{"code":"1F33A","sn":"hibiscus"},{"code":"1F33B","sn":"sunflower"},{"code":"1F33C","sn":"blossom"},{"code":"1F33D","sn":"corn"},{"code":"1F33E","sn":"ear_of_rice"},{"code":"1F33F","sn":"herb"},{"code":"1F340","sn":"four_leaf_clover"},{"code":"1F341","sn":"maple_leaf"},{"code":"1F342","sn":"fallen_leaf"},{"code":"1F343","sn":"leaves"},{"code":"1F344","sn":"mushroom"},{"code":"1F345","sn":"tomato"},{"code":"1F346","sn":"eggplant"},{"code":"1F347","sn":"grapes"},{"code":"1F348","sn":"melon"},{"code":"1F349","sn":"watermelon"},{"code":"1F34A","sn":"tangerine"},{"code":"1F34B","sn":"lemon"},{"code":"1F34C","sn":"banana"},{"code":"1F34D","sn":"pineapple"},{"code":"1F34E","sn":"apple"},{"code":"1F34F","sn":"green_apple"},{"code":"1F350","sn":"pear"},{"code":"1F351","sn":"peach"},{"code":"1F352","sn":"cherries"},{"code":"1F353","sn":"strawberry"},{"code":"1F354","sn":"hamburger"},{"code":"1F355","sn":"pizza"},{"code":"1F356","sn":"meat_on_bone"},{"code":"1F357","sn":"poultry_leg"},{"code":"1F358","sn":"rice_cracker"},{"code":"1F359","sn":"rice_ball"},{"code":"1F35A","sn":"rice"},{"code":"1F35B","sn":"curry"},{"code":"1F35C","sn":"ramen"},{"code":"1F35D","sn":"spaghetti"},{"code":"1F35E","sn":"bread"},{"code":"1F35F","sn":"fries"},{"code":"1F360","sn":"sweet_potato"},{"code":"1F361","sn":"dango"},{"code":"1F362","sn":"oden"},{"code":"1F363","sn":"sushi"},{"code":"1F364","sn":"fried_shrimp"},{"code":"1F365","sn":"fish_cake"},{"code":"1F366","sn":"icecream"},{"code":"1F367","sn":"shaved_ice"},{"code":"1F368","sn":"ice_cream"},{"code":"1F369","sn":"doughnut"},{"code":"1F36A","sn":"cookie"},{"code":"1F36B","sn":"chocolate_bar"},{"code":"1F36C","sn":"candy"},{"code":"1F36D","sn":"lollipop"},{"code":"1F36E","sn":"custard"},{"code":"1F36F","sn":"honey_pot"},{"code":"1F370","sn":"cake"},{"code":"1F371","sn":"bento"},{"code":"1F372","sn":"stew"},{"code":"1F373","sn":"egg"},{"code":"1F374","sn":"fork_and_knife"},{"code":"1F375","sn":"tea"},{"code":"1F376","sn":"sake"},{"code":"1F377","sn":"wine_glass"},{"code":"1F378","sn":"cocktail"},{"code":"1F379","sn":"tropical_drink"},{"code":"1F37A","sn":"beer"},{"code":"1F37B","sn":"beers"},{"code":"1F37C","sn":"baby_bottle"},{"code":"1F37D","sn":"knife_fork_plate"},{"code":"1F37E","sn":"champagne"},{"code":"1F37F","sn":"popcorn"},{"code":"1F380","sn":"ribbon"},{"code":"1F381","sn":"gift"},{"code":"1F382","sn":"birthday"},{"code":"1F383","sn":"jack_o_lantern"},{"code":"1F384","sn":"christmas_tree"},{"code":"1F385","sn":"santa"},{"code":"1F386","sn":"fireworks"},{"code":"1F387","sn":"sparkler"},{"code":"1F388","sn":"balloon"},{"code":"1F389","sn":"tada"},{"code":"1F38A","sn":"confetti_ball"},{"code":"1F38B","sn":"tanabata_tree"},{"code":"1F38C","sn":"crossed_flags"},{"code":"1F38D","sn":"bamboo"},{"code":"1F38E","sn":"dolls"},{"code":"1F38F","sn":"flags"},{"code":"1F390","sn":"wind_chime"},{"code":"1F391","sn":"rice_scene"},{"code":"1F392","sn":"school_satchel"},{"code":"1F393","sn":"mortar_board"},{"code":"1F396","sn":"medal"},{"code":"1F397","sn":"reminder_ribbon"},{"code":"1F399","sn":"studio_microphone"},{"code":"1F39A","sn":"level_slider"},{"code":"1F39B","sn":"control_knobs"},{"code":"1F39E","sn":"film_frames"},{"code":"1F39F","sn":"admission_tickets"},{"code":"1F3A0","sn":"carousel_horse"},{"code":"1F3A1","sn":"ferris_wheel"},{"code":"1F3A2","sn":"roller_coaster"},{"code":"1F3A3","sn":"fishing_pole_and_fish"},{"code":"1F3A4","sn":"microphone"},{"code":"1F3A5","sn":"movie_camera"},{"code":"1F3A6","sn":"cinema"},{"code":"1F3A7","sn":"headphones"},{"code":"1F3A8","sn":"art"},{"code":"1F3A9","sn":"tophat"},{"code":"1F3AA","sn":"circus_tent"},{"code":"1F3AB","sn":"ticket"},{"code":"1F3AC","sn":"clapper"},{"code":"1F3AD","sn":"performing_arts"},{"code":"1F3AE","sn":"video_game"},{"code":"1F3AF","sn":"dart"},{"code":"1F3B0","sn":"slot_machine"},{"code":"1F3B1","sn":"8ball"},{"code":"1F3B2","sn":"game_die"},{"code":"1F3B3","sn":"bowling"},{"code":"1F3B4","sn":"flower_playing_cards"},{"code":"1F3B5","sn":"musical_note"},{"code":"1F3B6","sn":"notes"},{"code":"1F3B7","sn":"saxophone"},{"code":"1F3B8","sn":"guitar"},{"code":"1F3B9","sn":"musical_keyboard"},{"code":"1F3BA","sn":"trumpet"},{"code":"1F3BB","sn":"violin"},{"code":"1F3BC","sn":"musical_score"},{"code":"1F3BD","sn":"running_shirt_with_sash"},{"code":"1F3BE","sn":"tennis"},{"code":"1F3BF","sn":"ski"},{"code":"1F3C0","sn":"basketball"},{"code":"1F3C1","sn":"checkered_flag"},{"code":"1F3C2","sn":"snowboarder"},{"code":"1F3C3","sn":"runner"},{"code":"1F3C4","sn":"surfer"},{"code":"1F3C5","sn":"sports_medal"},{"code":"1F3C6","sn":"trophy"},{"code":"1F3C7","sn":"horse_racing"},{"code":"1F3C8","sn":"football"},{"code":"1F3C9","sn":"rugby_football"},{"code":"1F3CA","sn":"swimmer"},{"code":"1F3CB","sn":"weight_lifter"},{"code":"1F3CC","sn":"golfer"},{"code":"1F3CD","sn":"racing_motorcycle"},{"code":"1F3CE","sn":"racing_car"},{"code":"1F3CF","sn":"cricket_bat_and_ball"},{"code":"1F3D0","sn":"volleyball"},{"code":"1F3D1","sn":"field_hockey_stick_and_ball"},{"code":"1F3D2","sn":"ice_hockey_stick_and_puck"},{"code":"1F3D3","sn":"table_tennis_paddle_and_ball"},{"code":"1F3D4","sn":"snow_capped_mountain"},{"code":"1F3D5","sn":"camping"},{"code":"1F3D6","sn":"beach_with_umbrella"},{"code":"1F3D7","sn":"building_construction"},{"code":"1F3D8","sn":"house_buildings"},{"code":"1F3D9","sn":"cityscape"},{"code":"1F3DA","sn":"derelict_house_building"},{"code":"1F3DB","sn":"classical_building"},{"code":"1F3DC","sn":"desert"},{"code":"1F3DD","sn":"desert_island"},{"code":"1F3DE","sn":"national_park"},{"code":"1F3DF","sn":"stadium"},{"code":"1F3E0","sn":"house"},{"code":"1F3E1","sn":"house_with_garden"},{"code":"1F3E2","sn":"office"},{"code":"1F3E3","sn":"post_office"},{"code":"1F3E4","sn":"european_post_office"},{"code":"1F3E5","sn":"hospital"},{"code":"1F3E6","sn":"bank"},{"code":"1F3E7","sn":"atm"},{"code":"1F3E8","sn":"hotel"},{"code":"1F3E9","sn":"love_hotel"},{"code":"1F3EA","sn":"convenience_store"},{"code":"1F3EB","sn":"school"},{"code":"1F3EC","sn":"department_store"},{"code":"1F3ED","sn":"factory"},{"code":"1F3EE","sn":"izakaya_lantern"},{"code":"1F3EF","sn":"japanese_castle"},{"code":"1F3F0","sn":"european_castle"},{"code":"1F3F3","sn":"waving_white_flag"},{"code":"1F3F4","sn":"waving_black_flag"},{"code":"1F3F5","sn":"rosette"},{"code":"1F3F7","sn":"label"},{"code":"1F3F8","sn":"badminton_racquet_and_shuttlecock"},{"code":"1F3F9","sn":"bow_and_arrow"},{"code":"1F3FA","sn":"amphora"},{"code":"1F3FB","sn":"skin-tone-2"},{"code":"1F3FC","sn":"skin-tone-3"},{"code":"1F3FD","sn":"skin-tone-4"},{"code":"1F3FE","sn":"skin-tone-5"},{"code":"1F3FF","sn":"skin-tone-6"},{"code":"1F400","sn":"rat"},{"code":"1F401","sn":"mouse2"},{"code":"1F402","sn":"ox"},{"code":"1F403","sn":"water_buffalo"},{"code":"1F404","sn":"cow2"},{"code":"1F405","sn":"tiger2"},{"code":"1F406","sn":"leopard"},{"code":"1F407","sn":"rabbit2"},{"code":"1F408","sn":"cat2"},{"code":"1F409","sn":"dragon"},{"code":"1F40A","sn":"crocodile"},{"code":"1F40B","sn":"whale2"},{"code":"1F40C","sn":"snail"},{"code":"1F40D","sn":"snake"},{"code":"1F40E","sn":"racehorse"},{"code":"1F40F","sn":"ram"},{"code":"1F410","sn":"goat"},{"code":"1F411","sn":"sheep"},{"code":"1F412","sn":"monkey"},{"code":"1F413","sn":"rooster"},{"code":"1F414","sn":"chicken"},{"code":"1F415","sn":"dog2"},{"code":"1F416","sn":"pig2"},{"code":"1F417","sn":"boar"},{"code":"1F418","sn":"elephant"},{"code":"1F419","sn":"octopus"},{"code":"1F41A","sn":"shell"},{"code":"1F41B","sn":"bug"},{"code":"1F41C","sn":"ant"},{"code":"1F41D","sn":"bee"},{"code":"1F41E","sn":"beetle"},{"code":"1F41F","sn":"fish"},{"code":"1F420","sn":"tropical_fish"},{"code":"1F421","sn":"blowfish"},{"code":"1F422","sn":"turtle"},{"code":"1F423","sn":"hatching_chick"},{"code":"1F424","sn":"baby_chick"},{"code":"1F425","sn":"hatched_chick"},{"code":"1F426","sn":"bird"},{"code":"1F427","sn":"penguin"},{"code":"1F428","sn":"koala"},{"code":"1F429","sn":"poodle"},{"code":"1F42A","sn":"dromedary_camel"},{"code":"1F42B","sn":"camel"},{"code":"1F42C","sn":"dolphin"},{"code":"1F42D","sn":"mouse"},{"code":"1F42E","sn":"cow"},{"code":"1F42F","sn":"tiger"},{"code":"1F430","sn":"rabbit"},{"code":"1F431","sn":"cat"},{"code":"1F432","sn":"dragon_face"},{"code":"1F433","sn":"whale"},{"code":"1F434","sn":"horse"},{"code":"1F435","sn":"monkey_face"},{"code":"1F436","sn":"dog"},{"code":"1F437","sn":"pig"},{"code":"1F438","sn":"frog"},{"code":"1F439","sn":"hamster"},{"code":"1F43A","sn":"wolf"},{"code":"1F43B","sn":"bear"},{"code":"1F43C","sn":"panda_face"},{"code":"1F43D","sn":"pig_nose"},{"code":"1F43E","sn":"feet"},{"code":"1F43F","sn":"chipmunk"},{"code":"1F440","sn":"eyes"},{"code":"1F441","sn":"eye"},{"code":"1F442","sn":"ear"},{"code":"1F443","sn":"nose"},{"code":"1F444","sn":"lips"},{"code":"1F445","sn":"tongue"},{"code":"1F446","sn":"point_up_2"},{"code":"1F447","sn":"point_down"},{"code":"1F448","sn":"point_left"},{"code":"1F449","sn":"point_right"},{"code":"1F44A","sn":"facepunch"},{"code":"1F44B","sn":"wave"},{"code":"1F44C","sn":"ok_hand"},{"code":"1F44D","sn":"+1"},{"code":"1F44E","sn":"-1"},{"code":"1F44F","sn":"clap"},{"code":"1F450","sn":"open_hands"},{"code":"1F451","sn":"crown"},{"code":"1F452","sn":"womans_hat"},{"code":"1F453","sn":"eyeglasses"},{"code":"1F454","sn":"necktie"},{"code":"1F455","sn":"shirt"},{"code":"1F456","sn":"jeans"},{"code":"1F457","sn":"dress"},{"code":"1F458","sn":"kimono"},{"code":"1F459","sn":"bikini"},{"code":"1F45A","sn":"womans_clothes"},{"code":"1F45B","sn":"purse"},{"code":"1F45C","sn":"handbag"},{"code":"1F45D","sn":"pouch"},{"code":"1F45E","sn":"mans_shoe"},{"code":"1F45F","sn":"athletic_shoe"},{"code":"1F460","sn":"high_heel"},{"code":"1F461","sn":"sandal"},{"code":"1F462","sn":"boot"},{"code":"1F463","sn":"footprints"},{"code":"1F464","sn":"bust_in_silhouette"},{"code":"1F465","sn":"busts_in_silhouette"},{"code":"1F466","sn":"boy"},{"code":"1F467","sn":"girl"},{"code":"1F468","sn":"man"},{"code":"1F469","sn":"woman"},{"code":"1F46A","sn":"family"},{"code":"1F46B","sn":"couple"},{"code":"1F46C","sn":"two_men_holding_hands"},{"code":"1F46D","sn":"two_women_holding_hands"},{"code":"1F46E","sn":"cop"},{"code":"1F46F","sn":"dancers"},{"code":"1F470","sn":"bride_with_veil"},{"code":"1F471","sn":"person_with_blond_hair"},{"code":"1F472","sn":"man_with_gua_pi_mao"},{"code":"1F473","sn":"man_with_turban"},{"code":"1F474","sn":"older_man"},{"code":"1F475","sn":"older_woman"},{"code":"1F476","sn":"baby"},{"code":"1F477","sn":"construction_worker"},{"code":"1F478","sn":"princess"},{"code":"1F479","sn":"japanese_ogre"},{"code":"1F47A","sn":"japanese_goblin"},{"code":"1F47B","sn":"ghost"},{"code":"1F47C","sn":"angel"},{"code":"1F47D","sn":"alien"},{"code":"1F47E","sn":"space_invader"},{"code":"1F47F","sn":"imp"},{"code":"1F480","sn":"skull"},{"code":"1F481","sn":"information_desk_person"},{"code":"1F482","sn":"guardsman"},{"code":"1F483","sn":"dancer"},{"code":"1F484","sn":"lipstick"},{"code":"1F485","sn":"nail_care"},{"code":"1F486","sn":"massage"},{"code":"1F487","sn":"haircut"},{"code":"1F488","sn":"barber"},{"code":"1F489","sn":"syringe"},{"code":"1F48A","sn":"pill"},{"code":"1F48B","sn":"kiss"},{"code":"1F48C","sn":"love_letter"},{"code":"1F48D","sn":"ring"},{"code":"1F48E","sn":"gem"},{"code":"1F48F","sn":"couplekiss"},{"code":"1F490","sn":"bouquet"},{"code":"1F491","sn":"couple_with_heart"},{"code":"1F492","sn":"wedding"},{"code":"1F493","sn":"heartbeat"},{"code":"1F494","sn":"broken_heart"},{"code":"1F495","sn":"two_hearts"},{"code":"1F496","sn":"sparkling_heart"},{"code":"1F497","sn":"heartpulse"},{"code":"1F498","sn":"cupid"},{"code":"1F499","sn":"blue_heart"},{"code":"1F49A","sn":"green_heart"},{"code":"1F49B","sn":"yellow_heart"},{"code":"1F49C","sn":"purple_heart"},{"code":"1F49D","sn":"gift_heart"},{"code":"1F49E","sn":"revolving_hearts"},{"code":"1F49F","sn":"heart_decoration"},{"code":"1F4A0","sn":"diamond_shape_with_a_dot_inside"},{"code":"1F4A1","sn":"bulb"},{"code":"1F4A2","sn":"anger"},{"code":"1F4A3","sn":"bomb"},{"code":"1F4A4","sn":"zzz"},{"code":"1F4A5","sn":"boom"},{"code":"1F4A6","sn":"sweat_drops"},{"code":"1F4A7","sn":"droplet"},{"code":"1F4A8","sn":"dash"},{"code":"1F4A9","sn":"hankey"},{"code":"1F4AA","sn":"muscle"},{"code":"1F4AB","sn":"dizzy"},{"code":"1F4AC","sn":"speech_balloon"},{"code":"1F4AD","sn":"thought_balloon"},{"code":"1F4AE","sn":"white_flower"},{"code":"1F4AF","sn":"100"},{"code":"1F4B0","sn":"moneybag"},{"code":"1F4B1","sn":"currency_exchange"},{"code":"1F4B2","sn":"heavy_dollar_sign"},{"code":"1F4B3","sn":"credit_card"},{"code":"1F4B4","sn":"yen"},{"code":"1F4B5","sn":"dollar"},{"code":"1F4B6","sn":"euro"},{"code":"1F4B7","sn":"pound"},{"code":"1F4B8","sn":"money_with_wings"},{"code":"1F4B9","sn":"chart"},{"code":"1F4BA","sn":"seat"},{"code":"1F4BB","sn":"computer"},{"code":"1F4BC","sn":"briefcase"},{"code":"1F4BD","sn":"minidisc"},{"code":"1F4BE","sn":"floppy_disk"},{"code":"1F4BF","sn":"cd"},{"code":"1F4C0","sn":"dvd"},{"code":"1F4C1","sn":"file_folder"},{"code":"1F4C2","sn":"open_file_folder"},{"code":"1F4C3","sn":"page_with_curl"},{"code":"1F4C4","sn":"page_facing_up"},{"code":"1F4C5","sn":"date"},{"code":"1F4C6","sn":"calendar"},{"code":"1F4C7","sn":"card_index"},{"code":"1F4C8","sn":"chart_with_upwards_trend"},{"code":"1F4C9","sn":"chart_with_downwards_trend"},{"code":"1F4CA","sn":"bar_chart"},{"code":"1F4CB","sn":"clipboard"},{"code":"1F4CC","sn":"pushpin"},{"code":"1F4CD","sn":"round_pushpin"},{"code":"1F4CE","sn":"paperclip"},{"code":"1F4CF","sn":"straight_ruler"},{"code":"1F4D0","sn":"triangular_ruler"},{"code":"1F4D1","sn":"bookmark_tabs"},{"code":"1F4D2","sn":"ledger"},{"code":"1F4D3","sn":"notebook"},{"code":"1F4D4","sn":"notebook_with_decorative_cover"},{"code":"1F4D5","sn":"closed_book"},{"code":"1F4D6","sn":"book"},{"code":"1F4D7","sn":"green_book"},{"code":"1F4D8","sn":"blue_book"},{"code":"1F4D9","sn":"orange_book"},{"code":"1F4DA","sn":"books"},{"code":"1F4DB","sn":"name_badge"},{"code":"1F4DC","sn":"scroll"},{"code":"1F4DD","sn":"memo"},{"code":"1F4DE","sn":"telephone_receiver"},{"code":"1F4DF","sn":"pager"},{"code":"1F4E0","sn":"fax"},{"code":"1F4E1","sn":"satellite_antenna"},{"code":"1F4E2","sn":"loudspeaker"},{"code":"1F4E3","sn":"mega"},{"code":"1F4E4","sn":"outbox_tray"},{"code":"1F4E5","sn":"inbox_tray"},{"code":"1F4E6","sn":"package"},{"code":"1F4E7","sn":"e-mail"},{"code":"1F4E8","sn":"incoming_envelope"},{"code":"1F4E9","sn":"envelope_with_arrow"},{"code":"1F4EA","sn":"mailbox_closed"},{"code":"1F4EB","sn":"mailbox"},{"code":"1F4EC","sn":"mailbox_with_mail"},{"code":"1F4ED","sn":"mailbox_with_no_mail"},{"code":"1F4EE","sn":"postbox"},{"code":"1F4EF","sn":"postal_horn"},{"code":"1F4F0","sn":"newspaper"},{"code":"1F4F1","sn":"iphone"},{"code":"1F4F2","sn":"calling"},{"code":"1F4F3","sn":"vibration_mode"},{"code":"1F4F4","sn":"mobile_phone_off"},{"code":"1F4F5","sn":"no_mobile_phones"},{"code":"1F4F6","sn":"signal_strength"},{"code":"1F4F7","sn":"camera"},{"code":"1F4F8","sn":"camera_with_flash"},{"code":"1F4F9","sn":"video_camera"},{"code":"1F4FA","sn":"tv"},{"code":"1F4FB","sn":"radio"},{"code":"1F4FC","sn":"vhs"},{"code":"1F4FD","sn":"film_projector"},{"code":"1F4FF","sn":"prayer_beads"},{"code":"1F500","sn":"twisted_rightwards_arrows"},{"code":"1F501","sn":"repeat"},{"code":"1F502","sn":"repeat_one"},{"code":"1F503","sn":"arrows_clockwise"},{"code":"1F504","sn":"arrows_counterclockwise"},{"code":"1F505","sn":"low_brightness"},{"code":"1F506","sn":"high_brightness"},{"code":"1F507","sn":"mute"},{"code":"1F508","sn":"speaker"},{"code":"1F509","sn":"sound"},{"code":"1F50A","sn":"loud_sound"},{"code":"1F50B","sn":"battery"},{"code":"1F50C","sn":"electric_plug"},{"code":"1F50D","sn":"mag"},{"code":"1F50E","sn":"mag_right"},{"code":"1F50F","sn":"lock_with_ink_pen"},{"code":"1F510","sn":"closed_lock_with_key"},{"code":"1F511","sn":"key"},{"code":"1F512","sn":"lock"},{"code":"1F513","sn":"unlock"},{"code":"1F514","sn":"bell"},{"code":"1F515","sn":"no_bell"},{"code":"1F516","sn":"bookmark"},{"code":"1F517","sn":"link"},{"code":"1F518","sn":"radio_button"},{"code":"1F519","sn":"back"},{"code":"1F51A","sn":"end"},{"code":"1F51B","sn":"on"},{"code":"1F51C","sn":"soon"},{"code":"1F51D","sn":"top"},{"code":"1F51E","sn":"underage"},{"code":"1F51F","sn":"keycap_ten"},{"code":"1F520","sn":"capital_abcd"},{"code":"1F521","sn":"abcd"},{"code":"1F522","sn":"1234"},{"code":"1F523","sn":"symbols"},{"code":"1F524","sn":"abc"},{"code":"1F525","sn":"fire"},{"code":"1F526","sn":"flashlight"},{"code":"1F527","sn":"wrench"},{"code":"1F528","sn":"hammer"},{"code":"1F529","sn":"nut_and_bolt"},{"code":"1F52A","sn":"hocho"},{"code":"1F52B","sn":"gun"},{"code":"1F52C","sn":"microscope"},{"code":"1F52D","sn":"telescope"},{"code":"1F52E","sn":"crystal_ball"},{"code":"1F52F","sn":"six_pointed_star"},{"code":"1F530","sn":"beginner"},{"code":"1F531","sn":"trident"},{"code":"1F532","sn":"black_square_button"},{"code":"1F533","sn":"white_square_button"},{"code":"1F534","sn":"red_circle"},{"code":"1F535","sn":"large_blue_circle"},{"code":"1F536","sn":"large_orange_diamond"},{"code":"1F537","sn":"large_blue_diamond"},{"code":"1F538","sn":"small_orange_diamond"},{"code":"1F539","sn":"small_blue_diamond"},{"code":"1F53A","sn":"small_red_triangle"},{"code":"1F53B","sn":"small_red_triangle_down"},{"code":"1F53C","sn":"arrow_up_small"},{"code":"1F53D","sn":"arrow_down_small"},{"code":"1F549","sn":"om_symbol"},{"code":"1F54A","sn":"dove_of_peace"},{"code":"1F54B","sn":"kaaba"},{"code":"1F54C","sn":"mosque"},{"code":"1F54D","sn":"synagogue"},{"code":"1F54E","sn":"menorah_with_nine_branches"},{"code":"1F550","sn":"clock1"},{"code":"1F551","sn":"clock2"},{"code":"1F552","sn":"clock3"},{"code":"1F553","sn":"clock4"},{"code":"1F554","sn":"clock5"},{"code":"1F555","sn":"clock6"},{"code":"1F556","sn":"clock7"},{"code":"1F557","sn":"clock8"},{"code":"1F558","sn":"clock9"},{"code":"1F559","sn":"clock10"},{"code":"1F55A","sn":"clock11"},{"code":"1F55B","sn":"clock12"},{"code":"1F55C","sn":"clock130"},{"code":"1F55D","sn":"clock230"},{"code":"1F55E","sn":"clock330"},{"code":"1F55F","sn":"clock430"},{"code":"1F560","sn":"clock530"},{"code":"1F561","sn":"clock630"},{"code":"1F562","sn":"clock730"},{"code":"1F563","sn":"clock830"},{"code":"1F564","sn":"clock930"},{"code":"1F565","sn":"clock1030"},{"code":"1F566","sn":"clock1130"},{"code":"1F567","sn":"clock1230"},{"code":"1F56F","sn":"candle"},{"code":"1F570","sn":"mantelpiece_clock"},{"code":"1F573","sn":"hole"},{"code":"1F574","sn":"man_in_business_suit_levitating"},{"code":"1F575","sn":"sleuth_or_spy"},{"code":"1F576","sn":"dark_sunglasses"},{"code":"1F577","sn":"spider"},{"code":"1F578","sn":"spider_web"},{"code":"1F579","sn":"joystick"},{"code":"1F587","sn":"linked_paperclips"},{"code":"1F58A","sn":"lower_left_ballpoint_pen"},{"code":"1F58B","sn":"lower_left_fountain_pen"},{"code":"1F58C","sn":"lower_left_paintbrush"},{"code":"1F58D","sn":"lower_left_crayon"},{"code":"1F590","sn":"raised_hand_with_fingers_splayed"},{"code":"1F595","sn":"middle_finger"},{"code":"1F596","sn":"spock-hand"},{"code":"1F5A5","sn":"desktop_computer"},{"code":"1F5A8","sn":"printer"},{"code":"1F5B1","sn":"three_button_mouse"},{"code":"1F5B2","sn":"trackball"},{"code":"1F5BC","sn":"frame_with_picture"},{"code":"1F5C2","sn":"card_index_dividers"},{"code":"1F5C3","sn":"card_file_box"},{"code":"1F5C4","sn":"file_cabinet"},{"code":"1F5D1","sn":"wastebasket"},{"code":"1F5D2","sn":"spiral_note_pad"},{"code":"1F5D3","sn":"spiral_calendar_pad"},{"code":"1F5DC","sn":"compression"},{"code":"1F5DD","sn":"old_key"},{"code":"1F5DE","sn":"rolled_up_newspaper"},{"code":"1F5E1","sn":"dagger_knife"},{"code":"1F5E3","sn":"speaking_head_in_silhouette"},{"code":"1F5E8","sn":"left_speech_bubble"},{"code":"1F5EF","sn":"right_anger_bubble"},{"code":"1F5F3","sn":"ballot_box_with_ballot"},{"code":"1F5FA","sn":"world_map"},{"code":"1F5FB","sn":"mount_fuji"},{"code":"1F5FC","sn":"tokyo_tower"},{"code":"1F5FD","sn":"statue_of_liberty"},{"code":"1F5FE","sn":"japan"},{"code":"1F5FF","sn":"moyai"},{"code":"1F600","sn":"grinning"},{"code":"1F601","sn":"grin"},{"code":"1F602","sn":"joy"},{"code":"1F603","sn":"smiley"},{"code":"1F604","sn":"smile"},{"code":"1F605","sn":"sweat_smile"},{"code":"1F606","sn":"laughing"},{"code":"1F607","sn":"innocent"},{"code":"1F608","sn":"smiling_imp"},{"code":"1F609","sn":"wink"},{"code":"1F60A","sn":"blush"},{"code":"1F60B","sn":"yum"},{"code":"1F60C","sn":"relieved"},{"code":"1F60D","sn":"heart_eyes"},{"code":"1F60E","sn":"sunglasses"},{"code":"1F60F","sn":"smirk"},{"code":"1F610","sn":"neutral_face"},{"code":"1F611","sn":"expressionless"},{"code":"1F612","sn":"unamused"},{"code":"1F613","sn":"sweat"},{"code":"1F614","sn":"pensive"},{"code":"1F615","sn":"confused"},{"code":"1F616","sn":"confounded"},{"code":"1F617","sn":"kissing"},{"code":"1F618","sn":"kissing_heart"},{"code":"1F619","sn":"kissing_smiling_eyes"},{"code":"1F61A","sn":"kissing_closed_eyes"},{"code":"1F61B","sn":"stuck_out_tongue"},{"code":"1F61C","sn":"stuck_out_tongue_winking_eye"},{"code":"1F61D","sn":"stuck_out_tongue_closed_eyes"},{"code":"1F61E","sn":"disappointed"},{"code":"1F61F","sn":"worried"},{"code":"1F620","sn":"angry"},{"code":"1F621","sn":"rage"},{"code":"1F622","sn":"cry"},{"code":"1F623","sn":"persevere"},{"code":"1F624","sn":"triumph"},{"code":"1F625","sn":"disappointed_relieved"},{"code":"1F626","sn":"frowning"},{"code":"1F627","sn":"anguished"},{"code":"1F628","sn":"fearful"},{"code":"1F629","sn":"weary"},{"code":"1F62A","sn":"sleepy"},{"code":"1F62B","sn":"tired_face"},{"code":"1F62C","sn":"grimacing"},{"code":"1F62D","sn":"sob"},{"code":"1F62E","sn":"open_mouth"},{"code":"1F62F","sn":"hushed"},{"code":"1F630","sn":"cold_sweat"},{"code":"1F631","sn":"scream"},{"code":"1F632","sn":"astonished"},{"code":"1F633","sn":"flushed"},{"code":"1F634","sn":"sleeping"},{"code":"1F635","sn":"dizzy_face"},{"code":"1F636","sn":"no_mouth"},{"code":"1F637","sn":"mask"},{"code":"1F638","sn":"smile_cat"},{"code":"1F639","sn":"joy_cat"},{"code":"1F63A","sn":"smiley_cat"},{"code":"1F63B","sn":"heart_eyes_cat"},{"code":"1F63C","sn":"smirk_cat"},{"code":"1F63D","sn":"kissing_cat"},{"code":"1F63E","sn":"pouting_cat"},{"code":"1F63F","sn":"crying_cat_face"},{"code":"1F640","sn":"scream_cat"},{"code":"1F641","sn":"slightly_frowning_face"},{"code":"1F642","sn":"slightly_smiling_face"},{"code":"1F643","sn":"upside_down_face"},{"code":"1F644","sn":"face_with_rolling_eyes"},{"code":"1F645","sn":"no_good"},{"code":"1F646","sn":"ok_woman"},{"code":"1F647","sn":"bow"},{"code":"1F648","sn":"see_no_evil"},{"code":"1F649","sn":"hear_no_evil"},{"code":"1F64A","sn":"speak_no_evil"},{"code":"1F64B","sn":"raising_hand"},{"code":"1F64C","sn":"raised_hands"},{"code":"1F64D","sn":"person_frowning"},{"code":"1F64E","sn":"person_with_pouting_face"},{"code":"1F64F","sn":"pray"},{"code":"1F680","sn":"rocket"},{"code":"1F681","sn":"helicopter"},{"code":"1F682","sn":"steam_locomotive"},{"code":"1F683","sn":"railway_car"},{"code":"1F684","sn":"bullettrain_side"},{"code":"1F685","sn":"bullettrain_front"},{"code":"1F686","sn":"train2"},{"code":"1F687","sn":"metro"},{"code":"1F688","sn":"light_rail"},{"code":"1F689","sn":"station"},{"code":"1F68A","sn":"tram"},{"code":"1F68B","sn":"train"},{"code":"1F68C","sn":"bus"},{"code":"1F68D","sn":"oncoming_bus"},{"code":"1F68E","sn":"trolleybus"},{"code":"1F68F","sn":"busstop"},{"code":"1F690","sn":"minibus"},{"code":"1F691","sn":"ambulance"},{"code":"1F692","sn":"fire_engine"},{"code":"1F693","sn":"police_car"},{"code":"1F694","sn":"oncoming_police_car"},{"code":"1F695","sn":"taxi"},{"code":"1F696","sn":"oncoming_taxi"},{"code":"1F697","sn":"car"},{"code":"1F698","sn":"oncoming_automobile"},{"code":"1F699","sn":"blue_car"},{"code":"1F69A","sn":"truck"},{"code":"1F69B","sn":"articulated_lorry"},{"code":"1F69C","sn":"tractor"},{"code":"1F69D","sn":"monorail"},{"code":"1F69E","sn":"mountain_railway"},{"code":"1F69F","sn":"suspension_railway"},{"code":"1F6A0","sn":"mountain_cableway"},{"code":"1F6A1","sn":"aerial_tramway"},{"code":"1F6A2","sn":"ship"},{"code":"1F6A3","sn":"rowboat"},{"code":"1F6A4","sn":"speedboat"},{"code":"1F6A5","sn":"traffic_light"},{"code":"1F6A6","sn":"vertical_traffic_light"},{"code":"1F6A7","sn":"construction"},{"code":"1F6A8","sn":"rotating_light"},{"code":"1F6A9","sn":"triangular_flag_on_post"},{"code":"1F6AA","sn":"door"},{"code":"1F6AB","sn":"no_entry_sign"},{"code":"1F6AC","sn":"smoking"},{"code":"1F6AD","sn":"no_smoking"},{"code":"1F6AE","sn":"put_litter_in_its_place"},{"code":"1F6AF","sn":"do_not_litter"},{"code":"1F6B0","sn":"potable_water"},{"code":"1F6B1","sn":"non-potable_water"},{"code":"1F6B2","sn":"bike"},{"code":"1F6B3","sn":"no_bicycles"},{"code":"1F6B4","sn":"bicyclist"},{"code":"1F6B5","sn":"mountain_bicyclist"},{"code":"1F6B6","sn":"walking"},{"code":"1F6B7","sn":"no_pedestrians"},{"code":"1F6B8","sn":"children_crossing"},{"code":"1F6B9","sn":"mens"},{"code":"1F6BA","sn":"womens"},{"code":"1F6BB","sn":"restroom"},{"code":"1F6BC","sn":"baby_symbol"},{"code":"1F6BD","sn":"toilet"},{"code":"1F6BE","sn":"wc"},{"code":"1F6BF","sn":"shower"},{"code":"1F6C0","sn":"bath"},{"code":"1F6C1","sn":"bathtub"},{"code":"1F6C2","sn":"passport_control"},{"code":"1F6C3","sn":"customs"},{"code":"1F6C4","sn":"baggage_claim"},{"code":"1F6C5","sn":"left_luggage"},{"code":"1F6CB","sn":"couch_and_lamp"},{"code":"1F6CC","sn":"sleeping_accommodation"},{"code":"1F6CD","sn":"shopping_bags"},{"code":"1F6CE","sn":"bellhop_bell"},{"code":"1F6CF","sn":"bed"},{"code":"1F6D0","sn":"place_of_worship"},{"code":"1F6E0","sn":"hammer_and_wrench"},{"code":"1F6E1","sn":"shield"},{"code":"1F6E2","sn":"oil_drum"},{"code":"1F6E3","sn":"motorway"},{"code":"1F6E4","sn":"railway_track"},{"code":"1F6E5","sn":"motor_boat"},{"code":"1F6E9","sn":"small_airplane"},{"code":"1F6EB","sn":"airplane_departure"},{"code":"1F6EC","sn":"airplane_arriving"},{"code":"1F6F0","sn":"satellite"},{"code":"1F6F3","sn":"passenger_ship"},{"code":"1F910","sn":"zipper_mouth_face"},{"code":"1F911","sn":"money_mouth_face"},{"code":"1F912","sn":"face_with_thermometer"},{"code":"1F913","sn":"nerd_face"},{"code":"1F914","sn":"thinking_face"},{"code":"1F915","sn":"face_with_head_bandage"},{"code":"1F916","sn":"robot_face"},{"code":"1F917","sn":"hugging_face"},{"code":"1F918","sn":"the_horns"},{"code":"1F980","sn":"crab"},{"code":"1F981","sn":"lion_face"},{"code":"1F982","sn":"scorpion"},{"code":"1F983","sn":"turkey"},{"code":"1F984","sn":"unicorn_face"},{"code":"1F9C0","sn":"cheese_wedge"},{"code":"0023-20E3","sn":"hash"},{"code":"002A-20E3","sn":"keycap_star"},{"code":"0030-20E3","sn":"zero"},{"code":"0031-20E3","sn":"one"},{"code":"0032-20E3","sn":"two"},{"code":"0033-20E3","sn":"three"},{"code":"0034-20E3","sn":"four"},{"code":"0035-20E3","sn":"five"},{"code":"0036-20E3","sn":"six"},{"code":"0037-20E3","sn":"seven"},{"code":"0038-20E3","sn":"eight"},{"code":"0039-20E3","sn":"nine"},{"code":"1F1E6-1F1E8","sn":"flag-ac"},{"code":"1F1E6-1F1E9","sn":"flag-ad"},{"code":"1F1E6-1F1EA","sn":"flag-ae"},{"code":"1F1E6-1F1EB","sn":"flag-af"},{"code":"1F1E6-1F1EC","sn":"flag-ag"},{"code":"1F1E6-1F1EE","sn":"flag-ai"},{"code":"1F1E6-1F1F1","sn":"flag-al"},{"code":"1F1E6-1F1F2","sn":"flag-am"},{"code":"1F1E6-1F1F4","sn":"flag-ao"},{"code":"1F1E6-1F1F6","sn":"flag-aq"},{"code":"1F1E6-1F1F7","sn":"flag-ar"},{"code":"1F1E6-1F1F8","sn":"flag-as"},{"code":"1F1E6-1F1F9","sn":"flag-at"},{"code":"1F1E6-1F1FA","sn":"flag-au"},{"code":"1F1E6-1F1FC","sn":"flag-aw"},{"code":"1F1E6-1F1FD","sn":"flag-ax"},{"code":"1F1E6-1F1FF","sn":"flag-az"},{"code":"1F1E7-1F1E6","sn":"flag-ba"},{"code":"1F1E7-1F1E7","sn":"flag-bb"},{"code":"1F1E7-1F1E9","sn":"flag-bd"},{"code":"1F1E7-1F1EA","sn":"flag-be"},{"code":"1F1E7-1F1EB","sn":"flag-bf"},{"code":"1F1E7-1F1EC","sn":"flag-bg"},{"code":"1F1E7-1F1ED","sn":"flag-bh"},{"code":"1F1E7-1F1EE","sn":"flag-bi"},{"code":"1F1E7-1F1EF","sn":"flag-bj"},{"code":"1F1E7-1F1F1","sn":"flag-bl"},{"code":"1F1E7-1F1F2","sn":"flag-bm"},{"code":"1F1E7-1F1F3","sn":"flag-bn"},{"code":"1F1E7-1F1F4","sn":"flag-bo"},{"code":"1F1E7-1F1F6","sn":"flag-bq"},{"code":"1F1E7-1F1F7","sn":"flag-br"},{"code":"1F1E7-1F1F8","sn":"flag-bs"},{"code":"1F1E7-1F1F9","sn":"flag-bt"},{"code":"1F1E7-1F1FB","sn":"flag-bv"},{"code":"1F1E7-1F1FC","sn":"flag-bw"},{"code":"1F1E7-1F1FE","sn":"flag-by"},{"code":"1F1E7-1F1FF","sn":"flag-bz"},{"code":"1F1E8-1F1E6","sn":"flag-ca"},{"code":"1F1E8-1F1E8","sn":"flag-cc"},{"code":"1F1E8-1F1E9","sn":"flag-cd"},{"code":"1F1E8-1F1EB","sn":"flag-cf"},{"code":"1F1E8-1F1EC","sn":"flag-cg"},{"code":"1F1E8-1F1ED","sn":"flag-ch"},{"code":"1F1E8-1F1EE","sn":"flag-ci"},{"code":"1F1E8-1F1F0","sn":"flag-ck"},{"code":"1F1E8-1F1F1","sn":"flag-cl"},{"code":"1F1E8-1F1F2","sn":"flag-cm"},{"code":"1F1E8-1F1F3","sn":"flag-cn"},{"code":"1F1E8-1F1F4","sn":"flag-co"},{"code":"1F1E8-1F1F5","sn":"flag-cp"},{"code":"1F1E8-1F1F7","sn":"flag-cr"},{"code":"1F1E8-1F1FA","sn":"flag-cu"},{"code":"1F1E8-1F1FB","sn":"flag-cv"},{"code":"1F1E8-1F1FC","sn":"flag-cw"},{"code":"1F1E8-1F1FD","sn":"flag-cx"},{"code":"1F1E8-1F1FE","sn":"flag-cy"},{"code":"1F1E8-1F1FF","sn":"flag-cz"},{"code":"1F1E9-1F1EA","sn":"flag-de"},{"code":"1F1E9-1F1EC","sn":"flag-dg"},{"code":"1F1E9-1F1EF","sn":"flag-dj"},{"code":"1F1E9-1F1F0","sn":"flag-dk"},{"code":"1F1E9-1F1F2","sn":"flag-dm"},{"code":"1F1E9-1F1F4","sn":"flag-do"},{"code":"1F1E9-1F1FF","sn":"flag-dz"},{"code":"1F1EA-1F1E6","sn":"flag-ea"},{"code":"1F1EA-1F1E8","sn":"flag-ec"},{"code":"1F1EA-1F1EA","sn":"flag-ee"},{"code":"1F1EA-1F1EC","sn":"flag-eg"},{"code":"1F1EA-1F1ED","sn":"flag-eh"},{"code":"1F1EA-1F1F7","sn":"flag-er"},{"code":"1F1EA-1F1F8","sn":"flag-es"},{"code":"1F1EA-1F1F9","sn":"flag-et"},{"code":"1F1EA-1F1FA","sn":"flag-eu"},{"code":"1F1EB-1F1EE","sn":"flag-fi"},{"code":"1F1EB-1F1EF","sn":"flag-fj"},{"code":"1F1EB-1F1F0","sn":"flag-fk"},{"code":"1F1EB-1F1F2","sn":"flag-fm"},{"code":"1F1EB-1F1F4","sn":"flag-fo"},{"code":"1F1EB-1F1F7","sn":"flag-fr"},{"code":"1F1EC-1F1E6","sn":"flag-ga"},{"code":"1F1EC-1F1E7","sn":"flag-gb"},{"code":"1F1EC-1F1E9","sn":"flag-gd"},{"code":"1F1EC-1F1EA","sn":"flag-ge"},{"code":"1F1EC-1F1EB","sn":"flag-gf"},{"code":"1F1EC-1F1EC","sn":"flag-gg"},{"code":"1F1EC-1F1ED","sn":"flag-gh"},{"code":"1F1EC-1F1EE","sn":"flag-gi"},{"code":"1F1EC-1F1F1","sn":"flag-gl"},{"code":"1F1EC-1F1F2","sn":"flag-gm"},{"code":"1F1EC-1F1F3","sn":"flag-gn"},{"code":"1F1EC-1F1F5","sn":"flag-gp"},{"code":"1F1EC-1F1F6","sn":"flag-gq"},{"code":"1F1EC-1F1F7","sn":"flag-gr"},{"code":"1F1EC-1F1F8","sn":"flag-gs"},{"code":"1F1EC-1F1F9","sn":"flag-gt"},{"code":"1F1EC-1F1FA","sn":"flag-gu"},{"code":"1F1EC-1F1FC","sn":"flag-gw"},{"code":"1F1EC-1F1FE","sn":"flag-gy"},{"code":"1F1ED-1F1F0","sn":"flag-hk"},{"code":"1F1ED-1F1F2","sn":"flag-hm"},{"code":"1F1ED-1F1F3","sn":"flag-hn"},{"code":"1F1ED-1F1F7","sn":"flag-hr"},{"code":"1F1ED-1F1F9","sn":"flag-ht"},{"code":"1F1ED-1F1FA","sn":"flag-hu"},{"code":"1F1EE-1F1E8","sn":"flag-ic"},{"code":"1F1EE-1F1E9","sn":"flag-id"},{"code":"1F1EE-1F1EA","sn":"flag-ie"},{"code":"1F1EE-1F1F1","sn":"flag-il"},{"code":"1F1EE-1F1F2","sn":"flag-im"},{"code":"1F1EE-1F1F3","sn":"flag-in"},{"code":"1F1EE-1F1F4","sn":"flag-io"},{"code":"1F1EE-1F1F6","sn":"flag-iq"},{"code":"1F1EE-1F1F7","sn":"flag-ir"},{"code":"1F1EE-1F1F8","sn":"flag-is"},{"code":"1F1EE-1F1F9","sn":"flag-it"},{"code":"1F1EF-1F1EA","sn":"flag-je"},{"code":"1F1EF-1F1F2","sn":"flag-jm"},{"code":"1F1EF-1F1F4","sn":"flag-jo"},{"code":"1F1EF-1F1F5","sn":"flag-jp"},{"code":"1F1F0-1F1EA","sn":"flag-ke"},{"code":"1F1F0-1F1EC","sn":"flag-kg"},{"code":"1F1F0-1F1ED","sn":"flag-kh"},{"code":"1F1F0-1F1EE","sn":"flag-ki"},{"code":"1F1F0-1F1F2","sn":"flag-km"},{"code":"1F1F0-1F1F3","sn":"flag-kn"},{"code":"1F1F0-1F1F5","sn":"flag-kp"},{"code":"1F1F0-1F1F7","sn":"flag-kr"},{"code":"1F1F0-1F1FC","sn":"flag-kw"},{"code":"1F1F0-1F1FE","sn":"flag-ky"},{"code":"1F1F0-1F1FF","sn":"flag-kz"},{"code":"1F1F1-1F1E6","sn":"flag-la"},{"code":"1F1F1-1F1E7","sn":"flag-lb"},{"code":"1F1F1-1F1E8","sn":"flag-lc"},{"code":"1F1F1-1F1EE","sn":"flag-li"},{"code":"1F1F1-1F1F0","sn":"flag-lk"},{"code":"1F1F1-1F1F7","sn":"flag-lr"},{"code":"1F1F1-1F1F8","sn":"flag-ls"},{"code":"1F1F1-1F1F9","sn":"flag-lt"},{"code":"1F1F1-1F1FA","sn":"flag-lu"},{"code":"1F1F1-1F1FB","sn":"flag-lv"},{"code":"1F1F1-1F1FE","sn":"flag-ly"},{"code":"1F1F2-1F1E6","sn":"flag-ma"},{"code":"1F1F2-1F1E8","sn":"flag-mc"},{"code":"1F1F2-1F1E9","sn":"flag-md"},{"code":"1F1F2-1F1EA","sn":"flag-me"},{"code":"1F1F2-1F1EB","sn":"flag-mf"},{"code":"1F1F2-1F1EC","sn":"flag-mg"},{"code":"1F1F2-1F1ED","sn":"flag-mh"},{"code":"1F1F2-1F1F0","sn":"flag-mk"},{"code":"1F1F2-1F1F1","sn":"flag-ml"},{"code":"1F1F2-1F1F2","sn":"flag-mm"},{"code":"1F1F2-1F1F3","sn":"flag-mn"},{"code":"1F1F2-1F1F4","sn":"flag-mo"},{"code":"1F1F2-1F1F5","sn":"flag-mp"},{"code":"1F1F2-1F1F6","sn":"flag-mq"},{"code":"1F1F2-1F1F7","sn":"flag-mr"},{"code":"1F1F2-1F1F8","sn":"flag-ms"},{"code":"1F1F2-1F1F9","sn":"flag-mt"},{"code":"1F1F2-1F1FA","sn":"flag-mu"},{"code":"1F1F2-1F1FB","sn":"flag-mv"},{"code":"1F1F2-1F1FC","sn":"flag-mw"},{"code":"1F1F2-1F1FD","sn":"flag-mx"},{"code":"1F1F2-1F1FE","sn":"flag-my"},{"code":"1F1F2-1F1FF","sn":"flag-mz"},{"code":"1F1F3-1F1E6","sn":"flag-na"},{"code":"1F1F3-1F1E8","sn":"flag-nc"},{"code":"1F1F3-1F1EA","sn":"flag-ne"},{"code":"1F1F3-1F1EB","sn":"flag-nf"},{"code":"1F1F3-1F1EC","sn":"flag-ng"},{"code":"1F1F3-1F1EE","sn":"flag-ni"},{"code":"1F1F3-1F1F1","sn":"flag-nl"},{"code":"1F1F3-1F1F4","sn":"flag-no"},{"code":"1F1F3-1F1F5","sn":"flag-np"},{"code":"1F1F3-1F1F7","sn":"flag-nr"},{"code":"1F1F3-1F1FA","sn":"flag-nu"},{"code":"1F1F3-1F1FF","sn":"flag-nz"},{"code":"1F1F4-1F1F2","sn":"flag-om"},{"code":"1F1F5-1F1E6","sn":"flag-pa"},{"code":"1F1F5-1F1EA","sn":"flag-pe"},{"code":"1F1F5-1F1EB","sn":"flag-pf"},{"code":"1F1F5-1F1EC","sn":"flag-pg"},{"code":"1F1F5-1F1ED","sn":"flag-ph"},{"code":"1F1F5-1F1F0","sn":"flag-pk"},{"code":"1F1F5-1F1F1","sn":"flag-pl"},{"code":"1F1F5-1F1F2","sn":"flag-pm"},{"code":"1F1F5-1F1F3","sn":"flag-pn"},{"code":"1F1F5-1F1F7","sn":"flag-pr"},{"code":"1F1F5-1F1F8","sn":"flag-ps"},{"code":"1F1F5-1F1F9","sn":"flag-pt"},{"code":"1F1F5-1F1FC","sn":"flag-pw"},{"code":"1F1F5-1F1FE","sn":"flag-py"},{"code":"1F1F6-1F1E6","sn":"flag-qa"},{"code":"1F1F7-1F1EA","sn":"flag-re"},{"code":"1F1F7-1F1F4","sn":"flag-ro"},{"code":"1F1F7-1F1F8","sn":"flag-rs"},{"code":"1F1F7-1F1FA","sn":"flag-ru"},{"code":"1F1F7-1F1FC","sn":"flag-rw"},{"code":"1F1F8-1F1E6","sn":"flag-sa"},{"code":"1F1F8-1F1E7","sn":"flag-sb"},{"code":"1F1F8-1F1E8","sn":"flag-sc"},{"code":"1F1F8-1F1E9","sn":"flag-sd"},{"code":"1F1F8-1F1EA","sn":"flag-se"},{"code":"1F1F8-1F1EC","sn":"flag-sg"},{"code":"1F1F8-1F1ED","sn":"flag-sh"},{"code":"1F1F8-1F1EE","sn":"flag-si"},{"code":"1F1F8-1F1EF","sn":"flag-sj"},{"code":"1F1F8-1F1F0","sn":"flag-sk"},{"code":"1F1F8-1F1F1","sn":"flag-sl"},{"code":"1F1F8-1F1F2","sn":"flag-sm"},{"code":"1F1F8-1F1F3","sn":"flag-sn"},{"code":"1F1F8-1F1F4","sn":"flag-so"},{"code":"1F1F8-1F1F7","sn":"flag-sr"},{"code":"1F1F8-1F1F8","sn":"flag-ss"},{"code":"1F1F8-1F1F9","sn":"flag-st"},{"code":"1F1F8-1F1FB","sn":"flag-sv"},{"code":"1F1F8-1F1FD","sn":"flag-sx"},{"code":"1F1F8-1F1FE","sn":"flag-sy"},{"code":"1F1F8-1F1FF","sn":"flag-sz"},{"code":"1F1F9-1F1E6","sn":"flag-ta"},{"code":"1F1F9-1F1E8","sn":"flag-tc"},{"code":"1F1F9-1F1E9","sn":"flag-td"},{"code":"1F1F9-1F1EB","sn":"flag-tf"},{"code":"1F1F9-1F1EC","sn":"flag-tg"},{"code":"1F1F9-1F1ED","sn":"flag-th"},{"code":"1F1F9-1F1EF","sn":"flag-tj"},{"code":"1F1F9-1F1F0","sn":"flag-tk"},{"code":"1F1F9-1F1F1","sn":"flag-tl"},{"code":"1F1F9-1F1F2","sn":"flag-tm"},{"code":"1F1F9-1F1F3","sn":"flag-tn"},{"code":"1F1F9-1F1F4","sn":"flag-to"},{"code":"1F1F9-1F1F7","sn":"flag-tr"},{"code":"1F1F9-1F1F9","sn":"flag-tt"},{"code":"1F1F9-1F1FB","sn":"flag-tv"},{"code":"1F1F9-1F1FC","sn":"flag-tw"},{"code":"1F1F9-1F1FF","sn":"flag-tz"},{"code":"1F1FA-1F1E6","sn":"flag-ua"},{"code":"1F1FA-1F1EC","sn":"flag-ug"},{"code":"1F1FA-1F1F2","sn":"flag-um"},{"code":"1F1FA-1F1F8","sn":"flag-us"},{"code":"1F1FA-1F1FE","sn":"flag-uy"},{"code":"1F1FA-1F1FF","sn":"flag-uz"},{"code":"1F1FB-1F1E6","sn":"flag-va"},{"code":"1F1FB-1F1E8","sn":"flag-vc"},{"code":"1F1FB-1F1EA","sn":"flag-ve"},{"code":"1F1FB-1F1EC","sn":"flag-vg"},{"code":"1F1FB-1F1EE","sn":"flag-vi"},{"code":"1F1FB-1F1F3","sn":"flag-vn"},{"code":"1F1FB-1F1FA","sn":"flag-vu"},{"code":"1F1FC-1F1EB","sn":"flag-wf"},{"code":"1F1FC-1F1F8","sn":"flag-ws"},{"code":"1F1FD-1F1F0","sn":"flag-xk"},{"code":"1F1FE-1F1EA","sn":"flag-ye"},{"code":"1F1FE-1F1F9","sn":"flag-yt"},{"code":"1F1FF-1F1E6","sn":"flag-za"},{"code":"1F1FF-1F1F2","sn":"flag-zm"},{"code":"1F1FF-1F1FC","sn":"flag-zw"},{"code":"1F468-200D-1F468-200D-1F466","sn":"man-man-boy"},{"code":"1F468-200D-1F468-200D-1F466-200D-1F466","sn":"man-man-boy-boy"},{"code":"1F468-200D-1F468-200D-1F467","sn":"man-man-girl"},{"code":"1F468-200D-1F468-200D-1F467-200D-1F466","sn":"man-man-girl-boy"},{"code":"1F468-200D-1F468-200D-1F467-200D-1F467","sn":"man-man-girl-girl"},{"code":"1F468-200D-1F469-200D-1F466-200D-1F466","sn":"man-woman-boy-boy"},{"code":"1F468-200D-1F469-200D-1F467","sn":"man-woman-girl"},{"code":"1F468-200D-1F469-200D-1F467-200D-1F466","sn":"man-woman-girl-boy"},{"code":"1F468-200D-1F469-200D-1F467-200D-1F467","sn":"man-woman-girl-girl"},{"code":"1F468-200D-2764-FE0F-200D-1F468","sn":"man-heart-man"},{"code":"1F468-200D-2764-FE0F-200D-1F48B-200D-1F468","sn":"man-kiss-man"},{"code":"1F469-200D-1F469-200D-1F466","sn":"woman-woman-boy"},{"code":"1F469-200D-1F469-200D-1F466-200D-1F466","sn":"woman-woman-boy-boy"},{"code":"1F469-200D-1F469-200D-1F467","sn":"woman-woman-girl"},{"code":"1F469-200D-1F469-200D-1F467-200D-1F466","sn":"woman-woman-girl-boy"},{"code":"1F469-200D-1F469-200D-1F467-200D-1F467","sn":"woman-woman-girl-girl"},{"code":"1F469-200D-2764-FE0F-200D-1F469","sn":"woman-heart-woman"},{"code":"1F469-200D-2764-FE0F-200D-1F48B-200D-1F469","sn":"woman-kiss-woman"}]

def get_emoji(name):
    for emoji in emojis:
        if emoji['sn'] == name.lower():
            return "&#" + str(int(emoji['code'], 16)) + ";"
    return ''

def replace_emoji(md):
    for m in re.finditer(r":([a-zA-Z0-9_]+):", md):
        md = md.replace(":"+ m.group(1) +":", get_emoji(m.group(1)))
    return md